<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css" />
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>

    <style>
        th {
            background-color: #45ab7d;
            color: white;
        }

        table {
            background-color: #eff5f1;
        }

        tr:nth-child(odd)>td {
            background-color: #e5f6e8;
        }

        th,
        td {
            border: 1px solid white;
        }

        .page-item.active .page-link {
            background-color: #d8f3dc !important;
            border: 1px solid #134735;
        }

        .page-link {
            color: #081c15 !important;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <h3 class="text-center my-3" style="color: #144433;">COURSE LIST</h3>

        <button class="btn btn-success mb-2" id="btn-add-course">
            + Add course
        </button>

        <table class="table" id="course-table">
            <thead>
                <th scope="col">STT</th>
                <th scope="col">Course Name</th>
                <th scope="col">Duration</th>
                <th scope="col">Level</th>
                <th scope="col">Price</th>
                <th scope="col">Discount Price</th>
                <th scope="col">Teacher Name</th>
                <th scope="col">Action</th>
            </thead>
            <tbody></tbody>
        </table>
    </div>

    <!-- Create course modal -->
    <div>
        <div id="create-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">
                            Create new course
                        </h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Course code</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-course-code" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Course name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-course-name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-price" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Discount price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-discount-price" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Duration</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-duration" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-level">Level</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-level" class="form-control">
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Cover image</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-cover-image" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Teacher name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-teacher-name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Teacher photo</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-teacher-photo" class="form-control" />
                                </div>
                            </div>

                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-popular">Popular</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-popular" class="form-control">
                                        <option value="false">No</option>
                                        <option value="true">Yes</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-trending">Trending</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-trending" class="form-control">
                                        <option value="false">No</option>
                                        <option value="true">Yes</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">
                            Cancel
                        </button>
                        <button class="btn btn-primary" id="btn-create-course">
                            Create Course
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Update course modal -->
    <div>
        <div id="update-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">
                            Update course
                        </h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Course code</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-course-code" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Course name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-course-name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-price" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Discount price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-discount-price" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Duration</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-duration" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-level">Level</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-level" class="form-control">
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Cover image</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-cover-image" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Teacher name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-teacher-name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label>Teacher photo</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-teacher-photo" class="form-control" />
                                </div>
                            </div>

                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-popular">Popular</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-popular" class="form-control">
                                        <option value="false">No</option>
                                        <option value="true">Yes</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-trending">Trending</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-trending" class="form-control">
                                        <option value="false">No</option>
                                        <option value="true">Yes</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">
                            Cancel
                        </button>
                        <button class="btn btn-primary" id="btn-update-course">
                            Update Course
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">
                            Course Delete Confirmation
                        </h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa course này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-course">
                            Confirm
                        </button>
                        <button class="btn btn-secondary" data-dismiss="modal">
                            Cancel
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

</html>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOURSE_COLS = [
        "stt",
        "courseName",
        "duration",
        "level",
        "price",
        "discountPrice",
        "teacherName",
        "action",
    ];

    const gSTT_COL = 0;
    const gCOURSE_NAME_COL = 1;
    const gDURATION_COL = 2;
    const gLEVEL_COL = 3;
    const gPRICE_COL = 4;
    const gDISCOUNT_PRICE_COL = 5;
    const gTEACHER_NAME_COL = 6;
    const gACTION_COL = 7;

    var gCourseId = 0;

    var gCourseTable = $("#course-table").DataTable({
        searching: false,
        ordering: false,
        columns: [
            { data: gCOURSE_COLS[gSTT_COL] },
            { data: gCOURSE_COLS[gCOURSE_NAME_COL] },
            { data: gCOURSE_COLS[gDURATION_COL] },
            { data: gCOURSE_COLS[gLEVEL_COL] },
            { data: gCOURSE_COLS[gPRICE_COL] },
            { data: gCOURSE_COLS[gDISCOUNT_PRICE_COL] },
            { data: gCOURSE_COLS[gTEACHER_NAME_COL] },
            { data: gCOURSE_COLS[gACTION_COL] },
        ],
        columnDefs: [
            {
                // định nghĩa lại cột STT
                targets: gSTT_COL,
                render: function (data, type, row, meta) {
                    return meta.row + meta.settings._iDisplayStart + 1;
                },
            },
            {
                // định nghĩa lại cột action
                targets: gACTION_COL,
                defaultContent: `
                    <i class="fas fa-edit edit-course" style = "color: #003049; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Sửa"></i>
                    <i class="fa fa-trash delete-course" aria-hidden="true" style = "color: #c1121f; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Xóa"></i>
                `,
            },
        ],
    });

    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    //gán sự kiện cho nút Add course
    $("#btn-add-course").on("click", function () {
        onBtnAddNewCourseClick();
    });
    // gán sự kiện cho nút Create Course (trên modal)
    $("#btn-create-course").on("click", function () {
        onBtnCreateCourseClick();
    });

    //gán sự kiện cho icon Edit course
    $(document).on("click", ".edit-course", function () {
        onBtnEditCourseClick(this);
    });
    //gán sự kiện cho nút Update Course (trên modal)
    $(document).on("click", "#btn-update-course", function () {
        onBtnUpdateCourseClick();
    });

    //gán sự kiện cho icon Delete course
    $(document).on("click", ".delete-course", function () {
        onBtnDeleteCourseClick(this);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi tải trang
    function onPageLoading() {
        getAllCourses();
    }

    //hàm thực thi khi nhấn icon Edit trên từng dòng
    function onBtnEditCourseClick(paramElement) {
        gCourseId = getCourseIdFromButton(paramElement);
        getCourseById(gCourseId);
    }

    //hàm thực thi khi nhấn nút Update Course trên modal
    function onBtnUpdateCourseClick() {
        var vCourseObj = {
            courseCode: "",
            courseName: "",
            price: 0,
            discountPrice: 0,
            duration: "",
            level: "",
            coverImage: "",
            teacherName: "",
            teacherPhoto: "",
            isPopular: false,
            isTrending: false,
        };
        // B1: Thu thập dữ liệu
        getUpdateCourseData(vCourseObj);
        // B2: Validate
        var vIsCourseValidate = validateCourseData(vCourseObj);
        if (vIsCourseValidate) {
            // B3: update course
            $.ajax({
                url: gBASE_URL + "courses/" + gCourseId,
                type: "PUT",
                contentType: "application/json",
                data: JSON.stringify(vCourseObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateCourseSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                },
            });
        }
    }

    //hàm thực thi khi nhấn icon Delete trên từng dòng
    function onBtnDeleteCourseClick(paramElement) {
        $("#delete-confirm-modal").modal("show");
        gCourseId = getCourseIdFromButton(paramElement);
        $(document).on("click", "#btn-confirm-delete-course", function () {
            $.ajax({
                url: gBASE_URL + "courses/" + gCourseId,
                type: "DELETE",
                success: function (res) {
                    alert("Xóa thành công");
                    getAllCourses();
                    $("#delete-confirm-modal").modal("hide");
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                },
            });
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy danh sách tất cả khóa học
    function getAllCourses() {
        $.ajax({
            url: gBASE_URL + "courses",
            type: "GET",
            success: function (res) {
                console.log(res);
                loadDataToCourseTable(res);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            },
        });
    }

    //hàm tải dữ liệu lên course table
    function loadDataToCourseTable(paramRes) {
        gCourseTable.clear();
        gCourseTable.rows.add(paramRes);
        gCourseTable.draw();
    }

    //hàm thực thi khi nhấn nút Add Course
    function onBtnAddNewCourseClick() {
        $("#create-course-modal").modal("show");
    }

    // hàm xử lý sự kiện create course modal click
    function onBtnCreateCourseClick() {
        var vCourseObj = {
            courseCode: "",
            courseName: "",
            price: 0,
            discountPrice: 0,
            duration: "",
            level: "",
            coverImage: "",
            teacherName: "",
            teacherPhoto: "",
            isPopular: false,
            isTrending: false,
        };
        // B1: Thu thập dữ liệu
        getCreateCourseData(vCourseObj);
        // B2: Validate
        var vIsCourseValidate = validateCourseData(vCourseObj);
        if (vIsCourseValidate) {
            // B3: create course
            $.ajax({
                url: gBASE_URL + "courses",
                type: "POST",
                contentType: "application/json",
                data: JSON.stringify(vCourseObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleCreateCourseSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                },
            });
        }
    }

    // Hàm thu thập dữ liệu create course
    function getCreateCourseData(paramCourseObj) {
        paramCourseObj.courseCode = $("#input-create-course-code").val().trim();
        paramCourseObj.courseName = $("#input-create-course-name").val().trim();
        paramCourseObj.price = $("#input-create-price").val().trim();
        paramCourseObj.discountPrice = $("#input-create-discount-price")
            .val()
            .trim();
        paramCourseObj.duration = $("#input-create-duration").val().trim();
        paramCourseObj.coverImage = $("#input-create-cover-image").val().trim();
        paramCourseObj.teacherName = $("#input-create-teacher-name").val().trim();
        paramCourseObj.teacherPhoto = $("#input-create-teacher-photo").val().trim();

        paramCourseObj.level = $("#select-create-level").val();
        paramCourseObj.isPopular = $("#select-create-popular").val();
        paramCourseObj.isTrending = $("#select-create-trending").val();
    }

    // hàm validate create course data
    function validateCourseData(paramCourseObj) {
        var vPriceNumber = Number(paramCourseObj.price);
        var vDiscountPriceNumber = Number(paramCourseObj.discountPrice);

        if (paramCourseObj.courseCode === "") {
            alert("Course code cần nhập");
            return false;
        }
        if (paramCourseObj.courseCode.length < 10) {
            alert("Course code cần chứa ít nhất 10 ký tự");
            return false;
        }

        if (paramCourseObj.courseName === "") {
            alert("Course name cần nhập");
            return false;
        }
        if (paramCourseObj.courseName.length < 20) {
            alert("Course name cần chứa ít nhất 20 ký tự");
            return false;
        }

        if (paramCourseObj.price === "") {
            alert("Price cần nhập");
            return false;
        }
        if (Number.isInteger(vPriceNumber) == false) {
            alert("Price cần là số nguyên");
            return false;
        }
        if (vPriceNumber <= 0) {
            alert("Price cần > 0");
            return false;
        }

        if (paramCourseObj.discountPrice === "") {
            alert("Discount price cần nhập");
            return false;
        }
        if (Number.isInteger(vDiscountPriceNumber) == false) {
            alert("Discount price cần là số nguyên");
            return false;
        }
        if (vDiscountPriceNumber < 0) {
            alert("Discount price cần >= 0");
            return false;
        }
        if (vDiscountPriceNumber > vPriceNumber) {
            alert("Discount price cần <= price");
            return false;
        }

        if (paramCourseObj.duration === "") {
            alert("Duration cần nhập");
            return false;
        }

        if (paramCourseObj.coverImage === "") {
            alert("Cover image cần nhập");
            return false;
        }

        if (paramCourseObj.teacherName === "") {
            alert("Teacher name cần nhập");
            return false;
        }

        if (paramCourseObj.teacherPhoto === "") {
            alert("Teacher photo cần nhập");
            return false;
        }

        return true;
    }

    //hàm xử lí hiển thị khi tạo course thành công
    function handleCreateCourseSuccess() {
        alert("Thêm course thành công!");
        getAllCourses();
        resertCreateCourseForm();
        $("#create-course-modal").modal("hide");
    }

    //hàm xóa data sau khi tạo course thành công
    function resertCreateCourseForm() {
        $("#input-create-course-code").val("");
        $("#input-create-course-name").val("");
        $("#input-create-price").val("");
        $("#input-create-discount-price").val("");
        $("#input-create-duration").val("");
        $("#input-create-cover-image").val("");
        $("#input-create-teacher-name").val("");
        $("#input-create-teacher-photo").val("");

        $("#select-create-level").val("Beginner");
        $("#select-create-popular").val("false");
        $("#select-create-trending").val("false");
    }

    // hàm dựa vào button detail (edit or delete) xác định đc id course
    function getCourseIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vCourseRowData = gCourseTable.row(vTableRow).data();
        return vCourseRowData.id;
    }

    // hàm get course by id
    function getCourseById(paramCourseId) {
        $.ajax({
            url: gBASE_URL + "courses/" + paramCourseId,
            type: "GET",
            success: function (paramCourse) {
                console.log(paramCourse);
                showCourseDataToModal(paramCourse);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            },
        });
        // hiển thị modal lên
        $("#update-course-modal").modal("show");
    }

    //hàm hiển thị data lên modal Update
    function showCourseDataToModal(paramCourse) {
        $("#input-update-course-code").val(paramCourse.courseCode);
        $("#input-update-course-name").val(paramCourse.courseName);
        $("#input-update-price").val(paramCourse.price);
        $("#input-update-discount-price").val(paramCourse.discountPrice);
        $("#input-update-duration").val(paramCourse.duration);
        $("#input-update-cover-image").val(paramCourse.coverImage);
        $("#input-update-teacher-name").val(paramCourse.teacherName);
        $("#input-update-teacher-photo").val(paramCourse.teacherPhoto);

        $("#select-update-level").val(paramCourse.level);
        $("#select-update-popular").val(paramCourse.isPopular.toString());
        $("#select-update-trending").val(paramCourse.isTrending.toString());
    }

    // Hàm thu thập dữ liệu update course
    function getUpdateCourseData(paramCourseObj) {
        paramCourseObj.courseCode = $("#input-update-course-code").val().trim();
        paramCourseObj.courseName = $("#input-update-course-name").val().trim();
        paramCourseObj.price = $("#input-update-price").val().trim();
        paramCourseObj.discountPrice = $("#input-update-discount-price")
            .val()
            .trim();
        paramCourseObj.duration = $("#input-update-duration").val().trim();
        paramCourseObj.coverImage = $("#input-update-cover-image").val().trim();
        paramCourseObj.teacherName = $("#input-update-teacher-name").val().trim();
        paramCourseObj.teacherPhoto = $("#input-update-teacher-photo").val().trim();

        paramCourseObj.level = $("#select-update-level").val();
        paramCourseObj.isPopular = $("#select-update-popular").val();
        paramCourseObj.isTrending = $("#select-update-trending").val();
    }

    //hàm xử lí hiển thị khi sửa course thành công
    function handleUpdateCourseSuccess() {
        alert("Sửa course thành công!");
        getAllCourses();
        resertUpdateCourseForm();
        $("#update-course-modal").modal("hide");
    }

    //hàm xóa data sau khi sửa course thành công
    function resertUpdateCourseForm() {
        $("#input-update-course-code").val("");
        $("#input-update-course-name").val("");
        $("#input-update-price").val("");
        $("#input-update-discount-price").val("");
        $("#input-update-duration").val("");
        $("#input-update-cover-image").val("");
        $("#input-update-teacher-name").val("");
        $("#input-update-teacher-photo").val("");

        $("#select-update-level").val("Beginner");
        $("#select-update-popular").val("false");
        $("#select-update-trending").val("false");
    }
</script>